#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Project Manager.ico
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
Opt ("RunErrorsFatal", 0)
Global $filesopen = 0, $projectfile = ""
Global $files[101][6]
$AutoItDir = RegRead ("HKLM\SOFTWARE\AutoIt v3\AutoIt", "InstallDir")
#include <File.au3>
#include <Array.au3>
#include <GUIConstants.au3>
#Include <WinAPI.au3>

$explorer = WinGetPos ("[CLASS:Shell_TrayWnd]")
$width = 178
$height = @DesktopHeight-($explorer[3]+30)
Global $movex = $width+5
Global $movey = 0
Global $resizex = @DesktopWidth-($movex)
Global $resizey = $height+32
Global $running = 0
Global $registry = "HKCU/AutoIt Project Manager"
Global $error = 0

#Region ### START Koda GUI section ### Form=p:\scripts\project manager\main.kxf
$Main = GUICreate("Project Manager", $width, $height, 0, 0)
Global $Tree = GUICtrlCreateTreeView(8, 8, $width-17, $height-40, BitOR($TVS_HASBUTTONS,$TVS_HASLINES,$TVS_LINESATROOT,$TVS_DISABLEDRAGDROP,$TVS_SHOWSELALWAYS,$WS_GROUP,$WS_TABSTOP,$WS_BORDER))

$File = GUICtrlCreateMenu("&File")
$New = GUICtrlCreateMenuItem("&New", $File)
$Open = GUICtrlCreateMenuItem("&Open", $File)
$Save = GUICtrlCreateMenuItem("&Save", $File)
GUICtrlSetState(-1, $GUI_DISABLE)
$Saveas = GUICtrlCreateMenuItem("S&ave as", $File)
GUICtrlSetState(-1, $GUI_DISABLE)
$Exit = GUICtrlCreateMenuItem("E&xit", $File)
$Project = GUICtrlCreateMenu("&Project")
GUICtrlSetState(-1, $GUI_DISABLE)
$Newscript = GUICtrlCreateMenuItem("&New Script", $Project)
$Linkscript = GUICtrlCreateMenuItem("&Link Script", $Project)
$Linkfile = GUICtrlCreateMenuItem("Link &File", $Project)
$Newsettingsfile = GUICtrlCreateMenuItem("New &Settings File", $Project)
$Test = GUICtrlCreateMenuItem("&Test", -1)
GUICtrlSetState(-1, $GUI_DISABLE)
$Compile = GUICtrlCreateMenuItem("&Compile", -1)
GUICtrlSetState(-1, $GUI_DISABLE)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

If Not WinExists ("[CLASS:SciTEWindow]") Then
	If FileExists ($AutoItDir&"\SciTE\SciTE.exe") Then 
		Run ($AutoItDir&"\SciTE\SciTE.exe")
	Else
		MsgBox (16, "ERROR", "Cannot find SciTE")
		$error = 1
	EndIf
EndIf
Global $originalpos = _ResizeSciTE ()
If $CmdLine > 0 And FileExists ($CmdLine[1]) Then _OpenFile ($CmdLine[1])

#Region ### START Koda GUI section ### Form=C:\Documents and Settings\Dale\My Documents\Scripts\Project Manager\Debugger.kxf
$Debugger = GUICreate("Debugger - AutoIt Project Manager", 633, 233, 193, 125, BitOR($WS_MAXIMIZEBOX,$WS_MINIMIZEBOX,$WS_SIZEBOX,$WS_THICKFRAME,$WS_SYSMENU,$WS_CAPTION,$WS_OVERLAPPEDWINDOW,$WS_TILEDWINDOW,$WS_POPUP,$WS_POPUPWINDOW,$WS_GROUP,$WS_TABSTOP,$WS_BORDER,$WS_CLIPSIBLINGS))
$Debugconsole = GUICtrlCreateEdit("", 8, 8, 617, 217, BitOR($ES_AUTOVSCROLL,$ES_AUTOHSCROLL,$ES_READONLY,$ES_WANTRETURN,$WS_HSCROLL,$WS_VSCROLL))
GUICtrlSetResizing(-1, $GUI_DOCKLEFT+$GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKBOTTOM)
#EndRegion ### END Koda GUI section ###

While 1
	If $running = 1 Then
		GUICtrlSetState ($debugger, @SW_SHOW)
		$console = StdoutRead ($process)
		If GUICtrlRead ($Debugconsole) <> $console Then
			GUICtrlSetData ($debugconsole, $console)
			If StringInStr ($console, "Exit code:") Then $running = 0
		EndIf
	EndIf
	$nMsg = GUIGetMsg(1)
	Switch $nMsg[0]
		Case $GUI_EVENT_CLOSE
			_Exit ()
		Case $Exit
			_Exit ()
		Case $New
			$continue = 0
			$projectfile = FileSaveDialog ("Save Project as...", "::{450D8FBA-AD25-11D0-98A8-0800361B1103}", "AutoIt Project File (*.auprj)", 14, "My Project.auprj")
			If Not @error Then
				$temp = StringSplit ($projectfile, "|")
				If $temp[0] <> 1 Then
					MsgBox (16, "Error", "You may only select one file to save to.")
				Else
					_FileCreate ($projectfile)
					If @error Then
						MsgBox (16, "Error", "Could not create project file.")
					Else
						$temp = _GetDir ($projectfile)
						$mainfile = FileSaveDialog ("Save main file as...", $temp, "AutoIt Script File (*.au3)", 14, "My AutoIt Script.au3")
						If Not @error Then
							$temp = StringSplit ($mainfile, "|")
							If $temp[0] <> 1 Then
								MsgBox (16, "Error", "You may only select one file to save to.")
							Else
								_FileCreate ($mainfile)
								If @error Then
									MsgBox (16, "Error", "Could not create main script file.")
								Else
									$files[0][1] = _GetDir ($mainfile)
									$files[0][2] = _GetFile ($files[0][1], $mainfile)
									$files[0][0] = GUICtrlCreateTreeViewItem ($files[0][2], $Tree)
									$files[0][3] = GUICtrlCreateContextMenu ($files[0][0])
									$files[0][4] = GUICtrlCreateMenuItem ("Edit", $files[0][3])
									IniWrite ($projectfile, "Files", "Main", $mainfile)
									GUICtrlSetState ($Project, $GUI_ENABLE)
									GUICtrlSetState ($Save, $GUI_ENABLE)
									GUICtrlSetState ($Saveas, $GUI_ENABLE)
									GUICtrlSetState ($Test, $GUI_ENABLE)
									GUICtrlSetState ($Compile, $GUI_ENABLE)
									$fileopen = 1
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		Case $Open
			$lastopen = RegRead ($registry, "Last open")
			If $lastopen = "" Or @error Then $lastopen = "::{450D8FBA-AD25-11D0-98A8-0800361B1103}"
			$projectfile = FileOpenDialog ("Open Project File...", $lastopen, "AutoIt Project File (*.auprj)", 3)
			If Not @error Then
				_OpenFile ($projectfile)
			EndIf
		Case $Save
			FileDelete ($projectfile)
			_FileCreate ($projectfile)
			If @error Then
				MsgBox (16, "Error", "Could not create project file.")
			Else
				_Saveas ($projectfile)
			EndIf
		Case $Saveas
			$projectfile = FileSaveDialog ("Save Project as...", "::{450D8FBA-AD25-11D0-98A8-0800361B1103}", "AutoIt Project File (*.auprj)", 14, "My Project.auprj")
			If Not @error Then
				$temp = StringSplit ($projectfile, "|")
				If $temp[0] <> 1 Then
					MsgBox (16, "Error", "You may only select one file to save to.")
				Else
					If StringRight ($projectfile, 6) = ".auprj" Then $projectfile &= ".auprj"
					_FileCreate ($projectfile)
					If @error Then
						MsgBox (16, "Error", "Could not create project file.")
					Else
						_Saveas ($projectfile)
					EndIf
				EndIf
			EndIf
		Case $Newscript
			For $i = 1 to 100
				If $files[$i][1] = "" Then
					$file = FileSaveDialog ("Save file as...", $files[0][1], "AutoIt Script File (*.au3)", 14, "My AutoIt Script.au3")
					If Not @error Then
						$temp = StringSplit ($file, "|")
						If $temp[0] <> 1 Then
							MsgBox (16, "Error", "You may only select one file to save to.")
						Else
							If StringRight ($projectfile, 4) = ".au3" Then $projectfile &= ".au3"
							_FileCreate ($file)
							If @error Then
								MsgBox (16, "Error", "Could not create main script file.")
							Else
								_AddScript ($file, $i)
								ExitLoop
							EndIf
						EndIf
					Else
						ExitLoop
					EndIf
				ElseIf $i = 100 Then
					MsgBox (48, "File Limit Reached", "You have created too many files for the program to handle."&@CRLF&"Try saving your project and re-opening."&@CRLF&"If this fails you will have to delete some files from your project.")
				EndIf
			Next
		Case $Linkscript
			For $i = 1 to 100
				If $files[$i][1] = "" Then
					$file = FileOpenDialog ("Link file", $files[0][1], "AutoIt Script File (*.au3)", 3, "My AutoIt Script.au3")
					If Not @error Then
						_AddScript ($file, $i)
						ExitLoop
					Else
						MsgBox (16, "Error", "Unkown error.")
					EndIf
				ElseIf $i = 100 Then
					MsgBox (48, "File Limit Reached", "You have created too many files for the program to handle."&@CRLF&"Try saving your project and re-opening."&@CRLF&"If this fails you will have to delete some files from your project.")
				EndIf
			Next
		Case $Linkfile
			For $i = 1 to 100
				If $files[$i][1] = "" Then
					$file = FileOpenDialog ("Link file", $files[0][1], "All Files (*.*)", 3)
					If Not @error Then
						_AddScript ($file, $i)
						ExitLoop
					Else
						ExitLoop
					EndIf
				ElseIf $i = 100 Then
					MsgBox (48, "File Limit Reached", "You have created too many files for the program to handle."&@CRLF&"Try saving your project and re-opening."&@CRLF&"If this fails you will have to delete some files from your project.")
				EndIf
			Next
		Case $Newsettingsfile
			For $i = 1 to 100
				If $files[$i][1] = "" Then
					$file = FileSaveDialog ("Save settings file as...", $files[0][1], "Settings File (*.ini)", 14, "My Settings File.ini")
					If Not @error Then
						$temp = StringSplit ($file, "|")
						If $temp[0] <> 1 Then
							MsgBox (16, "Error", "You may only select one file to save to.")
						Else
							If StringRight ($projectfile, 6) = ".ini" Then $projectfile &= ".ini"
							_FileCreate ($file)
							If @error Then
								MsgBox (16, "Error", "Could not create main script file.")
							Else
								_AddScript ($file, $i)
								ExitLoop
							EndIf
						EndIf
					Else
						ExitLoop
					EndIf
				ElseIf $i = 100 Then
					MsgBox (48, "File Limit Reached", "You have created too many files for the program to handle."&@CRLF&"Try saving your project and re-opening."&@CRLF&"If this fails you will have to delete some files from your project.")
				EndIf
			Next
		Case $Test
			$Parameters = InputBox ("Parameters", "Please input any parameters to run the main script with.")
			If Not @error Then
				$exe = $AutoItDir&'\SciTE\AutoIt3Wrapper\AutoIt3Wrapper.exe'
				$params = '/run /prod /ErrorStdOut /in "'&$Files[0][1]&"\"&$Files[0][2]&'" /autoit3dir "'&$AutoItDir&'" /UserParams '&$parameters
				MsgBox (48, "Project Testing", "Make sure all files used by the project are up to date.")
				$process = Run ($exe&" "&$params, "", "", 2)
				$running = 1
			EndIf
		Case $Compile
			ShellExecute ($AutoItDir&"\SciTE\AutoIt3Wrapper\AutoIt3Wrapper_Gui.exe", '/in "P:\Scripts\Project Manager\project manager.au3"')
		Case Else
			For $i = 0 to 100
				If $nMsg[0] = $files[$i][4] And $files[$i][4] <> "" Then
					ShellExecute ($files[$i][1]&"\"&$Files[$i][2], "", "", "Edit")
					_ResizeSciTE ()
				ElseIf $i > 0 And $nMsg[0] = $files[$i][5] And $files[$i][5] <> "" Then
					Do
						WinActivate ("[CLASS:SciTEWindow]")
					Until WinActive ("[CLASS:SciTEWindow]")
					Send ('{ASC 035}' & 'include "'&$files[$i][1]&'\'&$files[$i][2]&'"'&@CRLF)
				ElseIf $nMsg[0] = $files[0][5] And $files[$i][5] <> "" Then
					_CloseProject ()
				EndIf
			Next
	EndSwitch
WEnd

Func _CheckFile ($filef)
	$mainfile = IniRead($filef, "Files", "Main", "Error")
	If Not FileExists ($filef) Then
		MsgBox (16, "ERROR", "Cannot find project file.")
		ConsoleWrite ("Main project file not found."&@CRLF)
		Return 0
	Else
		If Not FileExists ($mainfile) Or $mainfile = "Error" Then
			MsgBox (16, "ERROR", "Cannot find main script file.")
			ConsoleWrite ("Main script file not found."&@CRLF)
			$dir = _GetDir ($mainfile)
			$mainfile = FileOpenDialog ("Main Script File", $dir, "AutoIt Script file (*.au3)", 3, _GetFile ($dir, $mainfile))
			If @error Then Return 0
			ConsoleWrite ("Main script file changed to "&$mainfile&@CRLF)
			IniWrite ($filef,  "Files", "Main", $mainfile)
		EndIf
		$ini = IniReadSection ($filef, "Files")
		For $i = 2 to $ini[0][0]
			If Not FileExists ($ini[$i][1]) Then
				ConsoleWrite ("Script file "&$i&" ("&$ini[$i][1]&") not found."&@CRLF)
				$dir = _GetDir ($ini[$i][1])
				$fileg = FileOpenDialog ("Script file", $dir, "AutoIt Script File (*.au3)", 3, _GetFile ($dir, $ini[$i][1]))
				If @error Then Return 0
				IniWrite ($filef, "Files", $i-1, $fileg)
				ConsoleWrite ("Script file "&$i&" changed to "&$fileg&@CRLF)
			EndIf
		Next
	EndIf
	Return 1
EndFunc

Func _Saveas ($projectfile)
	$current = 1
	IniWrite ($projectfile, "Files", "Main", $files[0][1]&"\"&$files[0][2])
	For $i = 1 to 100
		If $files[$i][1] <> "" Then
			IniWrite ($projectfile, "Files", $current, $files[$i][1]&"\"&$files[$i][2])
			$current += 1
		EndIf
	Next
	MsgBox (0, "Saved", "File Saved")
EndFunc

Func _AddScript ($file, $i)
	$files[$i][1] = _GetDir ($file)
	$files[$i][2] = _GetFile ($files[$i][1], $file)
	$files[$i][0] = GUICtrlCreateTreeViewItem ($files[$i][2], $files[0][0])
	$files[$i][3] = GUICtrlCreateContextMenu ($files[$i][0])
	$files[$i][4] = GUICtrlCreateMenuItem ("Edit", $files[$i][3])
	$files[$i][5] = GUICtrlCreateMenuItem ("Include in current file", $files[$i][3])
EndFunc

Func _GetDir ($file)
	$temp = StringSplit ($file, "\")
	If $temp[0] = 1 Then Return 0
	$dir = ""
	For $i = 1 to $temp[0]-1
		If $dir = "" Then
			$dir = $temp[$i]
		Else
			$dir = $dir&"\"&$temp[$i]
		EndIf
	Next
	Return $dir
EndFunc

Func _GetFile ($dir, $file)
	$file = StringTrimLeft ($file, StringLen ($dir)+1)
	Return $file
EndFunc

Func _ResizeSciTE ()
	If $error = 1 Then
		If WinExists ("[CLASS:SciTEWindow]") Then
			WinActivate ("[CLASS:SciTEWindow]")
			$originalposition = WinGetPos ("[CLASS:SciTEWindow]")
			WinMove ("[CLASS:SciTEWindow]", "", $movex, $movey, $resizex, $resizey)
		EndIf
	Else
		$i = 0
		While 1
			If WinExists ("[CLASS:SciTEWindow]") Then
				WinActivate ("[CLASS:SciTEWindow]")
				$originalposition = WinGetPos ("[CLASS:SciTEWindow]")
				WinMove ("[CLASS:SciTEWindow]", "", $movex, $movey, $resizex, $resizey)
				ExitLoop
			EndIf
			$i += 1
			If $i = 10000 Then
				MsgBox (16, "ERROR", "SciTE does not appear to be opening so AutoIt Project Manager will continue.")
				Return 0
			EndIf
		WEnd
	EndIf
	Return $originalposition
EndFunc

Func _OpenFile ($projectf)
	$mainfile = IniRead ($projectf, "Files", "Main", "") 
	$files[0][1] = _GetDir ($mainfile)
	RegWrite ($registry, "Last open", "REG_SZ", $files[0][1])
	$files[0][2] = _GetFile ($files[0][1], $mainfile)
	$t = _CheckFile ($projectf)
	If $t = 0 Then
		MsgBox (16, "ERROR", "Error opening project file")
	Else
		$files[0][0] = GUICtrlCreateTreeViewItem ($files[0][2], $Tree)
		$files[0][3] = GUICtrlCreateContextMenu ($files[0][0])
		$files[0][4] = GUICtrlCreateMenuItem ("Edit", $files[0][3])
		$files[0][5] = GUICtrlCreateMenuItem ("Close Project", $files[0][3])
		For $i = 1 to 100
			$file = IniRead ($projectf, "Files", $i, "ERROR")
			If $file <> "ERROR" Then
				_AddScript ($file, $i)
			EndIf
		Next
		GUICtrlSetState ($Project, $GUI_ENABLE)
		GUICtrlSetState ($Save, $GUI_ENABLE)
		GUICtrlSetState ($Saveas, $GUI_ENABLE)
		GUICtrlSetState ($Test, $GUI_ENABLE)
		GUICtrlSetState ($Compile, $GUI_ENABLE)
		$filesopen += 1
	EndIf
EndFunc

Func _CloseProject ()
	For $i = 0 to 100
		For $t = 3 to 5
			GUICtrlDelete ($files[$i][$t])
		Next
		GUICtrlDelete ($files[$i][0])
	Next
	$filesopen -= 1
	If $filesopen < 0 Then
		GUICtrlSetState ($Project, $GUI_DISABLE)
		GUICtrlSetState ($Save, $GUI_DISABLE)
		GUICtrlSetState ($Saveas, $GUI_DISABLE)
		GUICtrlSetState ($Test, $GUI_DISABLE)
		GUICtrlSetState ($Compile, $GUI_DISABLE)
	EndIf
EndFunc

Func _Exit ()
	If WinExists ("[CLASS:SciTEWindow]") Then
		WinActivate ("[CLASS:SciTEWindow]")
		WinMove ("[CLASS:SciTEWindow]", "", $originalpos[0], $originalpos[1], $originalpos[2], $originalpos[3])
	EndIf
	Exit
EndFunc